/* Exercise 8.
 Write a C program to calculate the weighted mean qualification of a student
 in a term.  The program must read from the keyboard the marks of the student
 (5 lectures, 6 exams per lecture --at most).
 
 The program must calculate the mean qualification by applying the weights:
 1.25 if the lecture is passed in the first exam,
 1 if the lecture is passed in the second exam,
 0.9 for the third exam,
 0.75 for the forth exam,
 0.6 for the fifth exam,
 0.5 for the sixth exam.
 
 (NOTE: Store the marks in a 2-dimension array of size 5x6;
 store the weights in a 1-dimension array of size 6.)
 */

#include <stdio.h>
#include <stdlib.h>

#define N_LEC 5  /* Number of courses */
#define N_EXA 6  /* Numbers of exams per course */
#define NON_VALID -1  /* Mark for non-valid cells */
#define PASS  5  /* Limit to pass the course */

int main(void)
{
    float marks[N_LEC][N_EXA];
    float weights[] = {1.25, 1, 0.9, 0.75, 0.6, 0.5};
    int i, j;
    float average;
    int expel;
    
    /* Read marks from the keyboard */
    i = 0;
    expel = 0;
    while(i < N_LEC && !expel) {
        
        j = 0;
        while(j < N_EXA && !expel) {
            float x;
            
            printf("Lecture %i - Exam %i: ", i, j);
            scanf("%f", &x);
            
            if(x >= 0 && x <= 10) {
                if(x < PASS && j == N_LEC-1) {
                    /* Last exam! */
                    printf("Last mark cannot be less than %i. ", PASS);
                    
                    printf("Should the student be expeled? (0: no, 1: yes) ");
                    scanf("%i", &expel);
                    
                } else {
                    marks[i][j] = x;
                    j++;
                    
                    if(x >= PASS) {
                        /* Fill row with special values */
                        while(j < N_EXA) {
                            marks[i][j] = NON_VALID;
                            j++;
                        }
                    }
                }
            }
        }
        
        i++;
    }
    
    /* Calculate average (only if not expelled) */
    
    if(!expel) {
    	average = 0;
        
    	for(i=0; i<N_LEC; i++) {
    		int found = 0;
            
    		for(j=0; j<N_EXA && !found; j++) {
    			if(marks[i][j] >= PASS) {
    				average += marks[i][j] * weights[j];
    				found = 1;
    			}
    		}
    	}
        
    	average /= N_LEC;
        
    	/* Print result */
    	printf("\nThe average is %f.\n", average);
        
    } else {
    	printf("No average. The student was expelled. \n");
    }
    
    /* End program */
    system("PAUSE");
    return 0;
}
